Subject: Re: [Sip] Re: gruu-10 focused review comments

From: Jonathan Rosenberg <[email-masked]>
Date: Mon, 11 Sep 2006 09:25:23 -0400

inline.

Dean Willis wrote:

> 
> On Aug 22, 2006, at 4:00 PM, Paul Kyzivat wrote:
> 
> I'll paste my confusion in-line.
> 
>> Suggested fix: Replace the first paragraph as follows:
>>
>> OLD:
>>    There is no new behavior associated with sending a request to a  GRUU.
>>    A GRUU is a URI like any other.  When a UA receives a request or
>>    response, it knows that the remote target is a GRUU by the presence
>>    of the "gruu" URI parameter.  The UA can take the GRUU, send a
>>    request to it, and then be sure that the request is delivered to  the
>>    UA instance which sent the request or response.
>>
>> NEW:
>>    A GRUU is a URI like any other.  When a UA receives a request or
>>    response, it knows that the remote target is a GRUU by the presence
>>    of the "gruu" URI parameter.  The UA can take the GRUU, send a
>>    request to it, and then be sure that the request is delivered to  the
>>    UA instance which sent the request or response.
> 
> 
> But we've already got people talking about redirecting or retargeting  
> requests that were sent to a GRUU -- perhaps in the UA, or perhaps in  
> some proxy.

Err - that should be squarely in the category of 'dont do that'. Can you 
point me to where that discussion is? I haven't noticed it.

> 
> And the GRUU, despite being "universally routable", isn't necessarily  
> reachable. It is just more likely to be reachable than the real Contact.

Well, if the network is down its not reachable, sure. But the whole 
point of the spec is that, assuming the network is working, it *will* be 
delivered to that specific UA instance. I'm missing the subtlety of what 
you are pointing out here.

> 
>>
>>    For UACs that have been assuming the URIs in contact headers in
>>    messages from others are globally routable there is no new behavior
>>    associated with sending a request to that URI when it is a GRUU.
>>
> 
> I like the preceding.
> 
>>    However some UACs have been assuming that URIs in received contact
>>    headers are not globally routable, and using ad hoc techniques when
>>    targetting requests to them. (E.g. Using the To or From-URI instead
>>    of the contact URI, or sending a new request in-dialog when an
>>    out-of-dialog request would otherwise be preferred.) A GRUU-aware
>>    UAC SHOULD treat a URI containing a "gruu" URI-parameter as  globally
>>    routable, and condition its actions accordingly, if it would
>>    otherwise consider that URI to not be globally routable.
>>
> 
> But the last sentence of the preceding lost me. It's a URI. Since I  
> know it is supposed to be a GRUU, I should try it before trying  tricky 
> transforms on the other URIs I have available (including AOR).  But I 
> might NOT actually be able to reach it. Are there still use  cases where 
> I'm going to fall back and try something tricky?

I think Paul answered this - yes. When the Contact doesn't have the gruu 
param, you do something tricky.

-Jonathan R.

-- 
Jonathan D. Rosenberg, Ph.D.                   600 Lanidex Plaza
Cisco Fellow                                   Parsippany, NJ 07054-2711
Cisco Systems
[email-masked]                              FAX:   (973) 952-5050
http://www.jdrosen.net                         PHONE: (973) 952-5000
http://www.cisco.com

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

---

From: Dean Willis <[email-masked]>
Date: Mon, 11 Sep 2006 13:04:01 -0500

On Sep 11, 2006, at 8:25 AM, Jonathan Rosenberg wrote:

>> But we've already got people talking about redirecting or  
>> retargeting  requests that were sent to a GRUU -- perhaps in the  
>> UA, or perhaps in  some proxy.
>
> Err - that should be squarely in the category of 'dont do that'.  
> Can you point me to where that discussion is? I haven't noticed it.
>

I'd be happy putting that in the "don't do that" category.

>
>> And the GRUU, despite being "universally routable", isn't  
>> necessarily  reachable. It is just more likely to be reachable  
>> than the real Contact.
>
> point of the spec is that, assuming the network is working, it  
> *will* be delivered to that specific UA instance. I'm missing the  
> subtlety of what you are pointing out here.

Are there situations where a UA would play the same kind of "try-to- 
transform to something reachable" from GRUU and AOR that it might  
play today with Contact and AOR?

Restated:

Today we present Contact and AOR values. Some UAs either assume or  
discover that the Contact is unreachable, leading them to try to  
transform the AOR into a device-specific identifier for transactions  
requiring such an identifier.

Is there a situation in which UA might make similar decisions about a  
GRUU? For example, "I have thi GRUU, but it isn't working (perhaps  
temporarily) so I'll fall back to a modified AOR?"

>> But the last sentence of the preceding lost me. It's a URI. Since  
>> I  know it is supposed to be a GRUU, I should try it before  
>> trying  tricky transforms on the other URIs I have available  
>> (including AOR).  But I might NOT actually be able to reach it.  
>> Are there still use  cases where I'm going to fall back and try  
>> something tricky?
>
> I think Paul answered this - yes. When the Contact doesn't have the  
> gruu param, you do something tricky.

I'm asking "Even if the Contact has the gruu param, will I need to do  
something tricky?"

--
Dean

---

From: "Spencer Dawkins" <[email-masked]>
Date: Mon, 11 Sep 2006 15:26:52 -0400

> transform to something reachable" from GRUU and AOR that it might  play 
> today with Contact and AOR?
>
> Restated:
>
> GRUU? For example, "I have this GRUU, but it isn't working (perhaps 

My apologies in advance if this isn't a reasonable response, but ...

Given that we already have

   a GRUU that's trying to make up for a Contact
   that isn't working,

could we call an end to this spiraling madness instead of trying to come up 
with

   a something that's trying to make up for
      a GRUU that's trying to make up for a Contact
      that isn't working
   that isn't working?

This last sentence sounds way too much like the beginning of a North 
American children's song ("there was an old lady who swallowed a fly", at 
http://www.niehs.nih.gov/kids/lyrics/oldlady.htm).

"If you came up with a GRUU that doesn't work, but something else would 
have, maybe you should be thinking about why your GRUU doesn't work..."

Thanks,

Spencer